'********************************************************************
' Serial Port Driver
'								    
' (c)Copyright Sealevel Systems Incorporated, 1993 - 1995	    
'								    
'  Please refer to the READ.ME file for Technical Support 
'  
'********************************************************************
' SCOM.bi
'********************************************************************
DECLARE FUNCTION InitPortCOM% (BYVAL wPORT AS INTEGER, BYVAL Value AS INTEGER)
DECLARE FUNCTION PutCharCOM% (BYVAL wPORT AS INTEGER, BYVAL Value AS INTEGER)
DECLARE FUNCTION GetCharCOM% (BYVAL wPORT AS INTEGER)
DECLARE FUNCTION ReqPortStatCOM% (BYVAL wPORT AS INTEGER)
DECLARE FUNCTION InitPortExCOM% (BYVAL wPORT AS INTEGER, BYVAL BAUD AS INTEGER, BYVAL PARITY AS INTEGER, BYVAL LENGTH AS INTEGER, BYVAL STOPBIT AS INTEGER)
DECLARE FUNCTION ReqPortStatExCOM% (BYVAL wPORT AS INTEGER, BYVAL Value AS INTEGER)
DECLARE FUNCTION GetBufferCountCOM% (BYVAL wPORT AS INTEGER, BYVAL Value AS INTEGER)
DECLARE SUB FlushBufferCOM (BYVAL wPORT AS INTEGER, BYVAL Value AS INTEGER)
' Not Supported DECLARE FUNCTION PutBlockCOM%(BYVAL Port AS INTEGER, BYVAL __far *lpWRITE, BYVAL LEN AS INTEGER)
' Not Supported DECLARE FUNCTION GetBlockCOM%(BYVAL Port AS INTEGER, BYVAL __far *lpREAD, BYVAL LEN AS INTEGER)
DECLARE FUNCTION HandShakeConfigCOM% (BYVAL Port AS INTEGER, BYVAL Value AS INTEGER)
DECLARE FUNCTION BaudRateConfigCOM% (BYVAL Port AS INTEGER, BYVAL BAUD AS INTEGER)
DECLARE SUB WritePortRegCOM (BYVAL Port AS INTEGER, BYVAL REG AS INTEGER, BYVAL Value AS INTEGER)
DECLARE FUNCTION ReadPortRegCOM% (BYVAL Port, BYVAL REG AS INTEGER)

'********************************************************************
'   Port Status
'********************************************************************
CONST RXBUFFERSTAT = 1
CONST OVERRUNERROR = 2
CONST PARITYERROR = 4
CONST FRAMEERROR = 8
CONST BREAKDETECTED = 16
CONST TXBUFFERSTAT = 32
CONST TXTIMEOUT = 128
'********************************************************************
'   Modem Status
'********************************************************************
CONST DELTACTS = 1
CONST DELTADSR = 2
CONST TRAILRI = 4
CONST DELTADCD = 8
CONST CTSSTAT = 16
CONST DSRSTAT = 32
CONST RISTAT = 64
CONST DCDSTAT = 128
'********************************************************************
'   Function 00: Initialize Port
'********************************************************************

CONST LBAUD110 = 0
CONST LBAUD150 = 32
CONST LBAUD300 = 64
CONST LBAUD600 = 96
CONST LBAUD1200 = 128
CONST LBAUD2400 = 160
CONST LBAUD4800 = 192
CONST LBAUD9600 = 224

CONST PARITYNONE = 0
CONST PARITYODD = 8
CONST PARITYEVEN = 24

CONST LSTOPBIT1 = 0
CONST LSTOPBIT2 = 4

CONST WORDLENGTH7 = 2
CONST WORDLENGTH8 = 3
'********************************************************************
'   Function 01: Transmit Character
'********************************************************************
CONST TXFAILED = 128		' Returns &H80 if failed

'********************************************************************
'   Function 02: Receive Character
'********************************************************************
CONST NOCHAR = 128

'********************************************************************
'   Function 03: Request Port Status
'       see Port Stauts and Modem Status above
'********************************************************************
'   Function 04: Extended Initialize Port
'       also see Port Status and Modem Status
'********************************************************************
CONST NOBREAK = 0
CONST BREAK = 1
CONST NOPARITY = 0
CONST ODDPARITY = 1
CONST EVENPARITY = 2
CONST STICKODDPARITY = 3
CONST STICKEVENPARITY = 4
CONST STOPBIT1 = 0
CONST STOPBIT2 = 1
CONST STOPBIT15 = 1	 ' valid if 5 data bits
CONST DATABITS5 = 0
CONST DATABITS6 = 1
CONST DATABITS7 = 2
CONST DATABITS8 = 3
CONST BAUD110 = 0
CONST BAUD150 = 1
CONST BAUD300 = 2
CONST BAUD600 = 3
CONST BAUD1200 = 4
CONST BAUD2400 = 5
CONST BAUD4800 = 6
CONST BAUD9600 = 7
CONST BAUD192K = 8
CONST BAUD384K = 9
CONST BAUD56K = 10
CONST BAUD1152K = 11
'********************************************************************
'   Function 05: Extended Port Control
'       also see Port Status and Modem Status
'********************************************************************
CONST READMCR = 0
CONST WRITEMCR = 256
CONST DTR = 1
CONST RTS = 2
CONST OUT1 = 4
CONST OUT2 = 8
CONST LOOPBIT = 16
'********************************************************************
'   Function 06: Get Buffer Count
'********************************************************************
CONST TXBUFFCOUNT = 0
CONST RXBUFFCOUNT = 1
CONST TXBUFFFREE = 2
CONST RXBUFFFREE = 3
'********************************************************************
'   Function 07: Flush Buffer
'********************************************************************
CONST TXFLUSH = 1
CONST RXFLUSH = 2
'********************************************************************
'   Function 08: Block Transmit
'********************************************************************
CONST PARTIALTX = 1

'********************************************************************
'   Function 09: Block Receive
'       none
'********************************************************************
'   Function 0A: Get / Set Handshake Mode
'********************************************************************
CONST SETHANDSHAKE = 0
CONST GETHANDSHAKE = 256
CONST SWTX = 1
CONST SWRX = 2
CONST DSRTX = 4
CONST DTRRX = 8
CONST CTSTX = 16
CONST RTSTX = 32
CONST RS485 = 32
CONST RTSON = 64
CONST DTRON = 128
'********************************************************************
'   Function 0B: Get / Set Non-Standard Baud Divisor
'********************************************************************
CONST GETDIVISOR = 0
'********************************************************************
'   Function 0C: Write to Any Port Register
'********************************************************************
CONST DATAREG = 0		 ' Can also read
CONST IERREG = 1		 ' Can also read
CONST FIFOREG = 2
CONST LCRREG = 3		 ' Can also read
CONST MCRREG = 4		 ' Can also read
CONST SCRATCHREG = 7		     ' Can also read
CONST DLABLSREG = 0		     ' Can also read
CONST DLABMSREG = 1		     ' Can also read

'********************************************************************
'   Function 0D: Read Any Port Register
'********************************************************************
CONST IIRREG = 2
CONST LSRREG = 5
CONST MSRREG = 6

'********************************************************************
'   End of File
'********************************************************************
